//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www.kamami.com
// PROJECT  : KAmodEXP2 Example
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple example of KAmodEXP2 using with ZL15AVR board
//
//    Settings and connections on ZL15AVR:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PD4 (con18)
//        D5 (LCD_CHAR/con13) - PD5 (con18)
//        D6 (LCD_CHAR/con13) - PD6 (con18)
//        D7 (LCD_CHAR/con13) - PD7 (con18)
//        E  (LCD_CHAR/con13) - PD2 (con18)
//        RS (LCD_CHAR/con13) - PD3 (con18)
//        RW (LCD_CHAR/con13) - GND (con15)
//
//
//   Connections between ZL15AVR and KAmodEXP2 :
//		  JP1 (ZL15AVR) - JP1 or JP2 (KAmodEXP2)	
//		  Con9(ZL15AVR) - Con4 (KAmodEXP2)
//
//   KAmodEXP2 settings
//	      JP0 (A0) - 0
//		  JP1 (A1) - 0
//        JP2 (A2) - 0
//
//******************************************************************************
#include <util/delay.h>
#include "KAmodEXP2.h"
#include "HD44780.h"

#define DEV_ADDR	 0  // Hadrware addres of KAmodEXP1 (JP0=0 JP1=0 JP2 = 0)
//#define DEV_ADDR	 1  // Hadrware addres of KAmodEXP1 (JP0=1 JP1=0 JP2 = 0)
//#define DEV_ADDR	 2  // Hadrware addres of KAmodEXP1 (JP0=0 JP1=1 JP2 = 0)
//#define DEV_ADDR	 3  // Hadrware addres of KAmodEXP1 (JP0=1 JP1=1 JP2 = 0)
//#define DEV_ADDR	 4  // Hadrware addres of KAmodEXP1 (JP0=0 JP1=0 JP2 = 1)
//#define DEV_ADDR	 5  // Hadrware addres of KAmodEXP1 (JP0=1 JP1=0 JP2 = 1)
//#define DEV_ADDR	 6  // Hadrware addres of KAmodEXP1 (JP0=0 JP1=1 JP2 = 1)
//#define DEV_ADDR	 7  // Hadrware addres of KAmodEXP1 (JP0=1 JP1=1 JP2 = 1)

//-----------------------------------------------------------------------------
// Display output state on LCD
//-----------------------------------------------------------------------------
void SetOutScreen(unsigned char Out)
{
unsigned char i;
char  String[5];

LCD_GoTo(0,1);					// second line
LCD_WriteText("Out:");			// Display string
LCD_WriteText(Hex(Out, String));// Display hex value
LCD_WriteData(' ');				// Display space
LCD_WriteBinary(Out, 8);		// Display binary value
for(i = 0; i < 50; i ++)		// Some delay
  _delay_ms(10);				//
}
//-----------------------------------------------------------------------------
// Main function
//-----------------------------------------------------------------------------
int main(void)
{
unsigned char DelayTime;
unsigned char Counter;
unsigned int Output = 1;

LCD_Initialize();
LCD_Clear();
LCD_GoTo(0,0);										// Welcome screen
LCD_WriteText("*** KAmodEXP2***");					//
LCD_GoTo(0,1);										//
LCD_WriteText("    Example");		

KAmodEXP2_Init();									// Init hardware
KAmodEXP2_WriteReg(DEV_ADDR, IODIR, 0x00);			// GPIO as output
KAmodEXP2_WriteReg(DEV_ADDR, GPIO,  0x55);

for(DelayTime = 0; DelayTime < 50; DelayTime ++)	// Some delay
	_delay_ms(30);									//

LCD_GoTo(0,1);										// Clear second line
LCD_WriteText("                ");					//

// infinite loop
do{
  //-------------
  // effect 1
  //-------------
  for(Output = 1; Output != 0x100; Output <<= 1)
  {
  KAmodEXP2_WriteReg(DEV_ADDR, GPIO, Output);
  SetOutScreen(Output);
  }
  //-------------
  // effect 2
  //-------------
  for(Output = 1; Output < 255; Output <<= 1)
  {
   Output |= 1;
   KAmodEXP2_WriteReg(DEV_ADDR, GPIO, Output);
   SetOutScreen(Output);
  }
  //-------------
  // effect 3
  //-------------
  for(Counter = 0; Counter < 8; Counter ++)
  {
  Output = 0xAA;
  KAmodEXP2_WriteReg(DEV_ADDR, GPIO, Output);
  SetOutScreen(Output);
  Output = 0x55;
  KAmodEXP2_WriteReg(DEV_ADDR, GPIO, Output);
  SetOutScreen(Output);
  }
}while(1);
return 0;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
